\ psr.fs

:m outbit 6 .P1 m;  \ LED
:m clue 7 .P1 m;  \ For timing

:m +clue clue set m; :m -clue clue clr m;
\ :m +clue m; :m -clue m; \ disappear.

cpuHERE constant sequence 4 cpuALLOT
\ XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX
\ ^ bit 31      ^ bit 18
\ ^ sequence        ^ sequence+2

\ If all bits are clear, reseed with $aaaaaaaa.
: ?seed 
	sequence # a! $aa #
	dup !+ dup !+ dup !+ ! ;

\ Shift once with feedback from bits 18 and 31.
:m psr	+clue
	[ sequence 1 + ] #@  \ Get bit 18.
	[ 2 .T movbc 7 .T movcb ]  \ Move it to bit 7 of TOS.
	sequence #@ xor  \ xor bits 31 and 18.
	2*'  \ Move xored bit into carry.
	outbit movcb
	\ Shift xored bit into sequence.
	[ sequence 3 + ] (#@) 2*' [ sequence 3 + ] (#!)
	[ sequence 2 + ] (#@) 2*' [ sequence 2 + ] (#!)
	[ sequence 1 + ] (#@) 2*' [ sequence 1 + ] (#!)
	[ sequence 0 + ] (#@) 2*' [ sequence 0 + ] (#!)
	drop -clue m;

\ View current shift register in hex.
: .psr  cr
	[ sequence 0 + ] #@ h.
	[ sequence 1 + ] #@ h.
	[ sequence 2 + ] #@ h.
	[ sequence 3 + ] #@ h.
	space
	[ sequence 0 + ] #@ u.
	[ sequence 1 + ] #@ u.
	[ sequence 2 + ] #@ u.
	[ sequence 3 + ] #@ u.
	space
	[ sequence 1 + ] #@
	[ sequence 2 + ] #@ d.
	;

\ Load a seed value in the shift register.
: psr! ( n1 n2 n3 n4 - ) sequence # a! !+ !+ !+ ! ;

\ Note that #@ and #! push and pop the data stack, but
\ (#@) and (#!) assume the top of stack is already free to be used, so
\ don't need to push or pop.

: 0psr  0 # dup dup dup psr! ?seed ;
: init  0psr 0 # 7 #for  psr  7 #next ;
: t  13 # 7 #for psr 7 #next .psr ;

: go init-xbr 0psr begin psr again

: ~P1.6 6 .P1 toggle ;
: ~P1.7 7 .P1 toggle ;

