\ application.fs

\ Change internal oscillator speed.
: speed/8  SFRf $fc # OSCICN and! SFR0 ;
: speed/4  speed/8 1 # OSCICN ior! SFR0 ;
: speed/2  speed/8 2 # OSCICN ior! SFR0 ;
: speed/1  SFRf 3 # OSCICN ior! SFR0 ;

: s1  speed/1 blinker 
: s2  speed/2 blinker 
: s4  speed/4 blinker 
: s8  speed/8 blinker ;

\ Experiment with bit-banged SPI.
$a6 constant P2MDOUT  \ $0f
:m SCLK 0 .P2 m;
:m MOSI 1 .P2 m;
:m MISO 2 .P2 m;

: +P2.0 [ SCLK set ] ;
: -P2.0 [ SCLK clr ] ;
 
:m init-SPI SFRf $07 # P2MDOUT #! SFR0 m;

:m spi-bit ( n1 - n2)
	[ 7 .T movbc  MOSI movcb  SCLK set
	MISO movbc ] 2*' [ SCLK clr ] m;
: spi-byte ( n1 - n2)
	spi-bit spi-bit spi-bit spi-bit
	spi-bit spi-bit spi-bit spi-bit ;

: test	init-SPI
	begin
		$a5 # spi-byte drop
		0 # 7 #for 7 #next
	again

