\ preamble.fs
:m ~# [ invert ] # m;

$84 constant SFRPAGE  \ all
:m SFR-0 $00 # SFRPAGE #! m;
:m SFR-1 $01 # SFRPAGE #! m;
:m SFR-f $0f # SFRPAGE #! m;

\ SFR definitions.
$e1 constant XBR0  \ $0f
$e2 constant XBR1  \ $0f
$e3 constant XBR2  \ $0f
$a4 constant P0MDOUT  \ $0f
$a5 constant P1MDOUT  \ $0f
$a6 constant P2MDOUT  \ $0f
$8a constant OSCICN  \ 0f
$b7 constant FLSCL   \ $00
$89 constant PLL0CN  \ $0f
$8d constant PLL0DIV  \ $0f
$8e constant PLL0MUL  \ $0f
$8f constant PLL0FLT  \ $0f
$97 constant CLKSEL  \ $0f
$9a constant SPI0CFG  \ $00
$f8 constant SPI0CN  \ $00
$9d constant SPI0CKR  \ $00
$9b constant SPI0DAT  \ $00
[ : .SPI0CN SPI0CN + ; ]
[ : .SPI0DAT SPI0DAT + ; ]

\ Use PLL for more speed.
:m wait-at-least-5us 0 # 7 #for 7 #next m;

here value (98MHz)
: 98MHz 
	SFR-f 3 # OSCICN ior!  \ Internal clock full speed.
	4 ~# PLL0CN and!  \ Reference clock is internal.
	SFR-0 $30 # FLSCL ior!  \ SYSCLK <= 100MHz.
	SFR-f $01 # PLL0CN ior!  \ Enable PLL Power.
	$01 # PLL0DIV #!  \ Divide by 1, 24.5MHz.
	$01 # PLL0FLT #!  \ Filter for 25MHz -> 100MHz.
	$04 # PLL0MUL #!  \ Multiply internal clock by 4.
	wait-at-least-5us
	2 # PLL0CN ior!  \ Enable the PLL.
	0 # begin  drop PLL0CN #@ $10 # and until drop
	$02 # CLKSEL #!  \ Make PLL the Clock Source.
	SFR-0 ;

\ Test by running 98MHz, then 38400baud.
\ Try interactive testing, then run blinker and note the timing on the
\ LED.
\ [ : 38400baud  (  - )
\	close-comm N81 38400 baud
\	"portname r/o open-file ?serial-problem serial-fid ! ; ]

\ After downloading at 24.5MHz and 9600 baud, speed things up.
\ :m fast (98MHz) (talk) 38400baud m;

\ Use LED to see speed change.
: init-LED SFR-f $40 # P1MDOUT #! SFR-0 ;
:m LED 6 .P1 m;
: +LED LED set ;
: -LED LED clr ;
: delay 0 # 7 #for 0 # 6 #for 50 # 5 #for 5 #next 6 #next 7 #next ;
: blinker init-LED begin LED toggle delay again

